#!/usr/bin/perl

#workdir
$wdir = 'wdir/';
#temporary file for stdin emulation
$tmp_stdin = 'tmp_stdin_';

# time of file expiration
$exp_time_in_min = '120';

#need to set for security reasons (we'll launch _only_ current dir executables)
$ENV{PATH} = ".";

sub PrettyPrint {
    print "<font color=\"#005500\">";
     while(<$f>) {
      # NL --> CR NL
      s/\12/\15\12/;
      s/\&/\&amp\;/g;
      s/ /\&nbsp\;/g;
      s/\</\&lt\;/g;
      s/\>/\&gt\;/g;
      s/\"/\&quot\;/g;
      print "$_<BR>"; 
    };
    print "</font>";
}

sub Error2Html {
    print "Content-type: text/html\n\n" .
           "<HTML>\n<HEAD>\n<TITLE>Error</TITLE>\n</HEAD>\n" .
            "<BODY TEXT=\"#aa0000\" BGCOLOR=\"#ffffff\">\n" .
                "<center><b>@_[0]</b></center>";
    if (defined(@_[1])){
	print "@_[1]\n"
    }
    print "</BODY></HTML>";
    exit 1;
}

sub DeleteExpired () {

    $dir = "./wdir";    
    
    opendir(DIR, $dir) || die "can't opendir $dir";
    @file_list = grep { !/^\./} readdir(DIR);
    closedir DIR;
    
    $current_time = (time);
    $exp_time = $exp_time_in_min * 60;  

    foreach $file (@file_list) {
	if ((($file =~ /^tmp_ref/) || ($file =~ /^tmp_stdin/)) &&
	    ((@file_stat) = stat ("$dir/$file")) &&
	    ($current_time - @file_stat[9]) > $exp_time) {
	    print `./rm -l "$dir/$file" `;
	}
    }
}



if ($ENV{'REQUEST_METHOD'} eq 'POST') {
    $length =  $ENV{'CONTENT_LENGTH'};
    $nread = read STDIN, $buffer, $length;
}

if (($query = $ENV{'QUERY_STRING'}) ne "") {
#	Error2Html ("$query");

    @forminputs = split (/&/, $query);
    foreach $forminput (@forminputs) {
	($name, $value) = split (/=/, $forminput);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack ("C", hex($1))/eg;
	$value =~ s/\r\n/\n/g;
	$form{$name} = $value;
    }
}

@forminputs = split (/&/, $buffer);
foreach $forminput (@forminputs) {
    ($name, $value) = split (/=/, $forminput);
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack ("C", hex($1))/eg;
    $value =~ s/\r\n/\n/g;
    $form{$name} = $value;
}

$state = $form{'state'};
$modules = '';
$index = 0;
@xmodes = ("Normal", "For pure HTML output", "Interactive");

if ($state == 3) {
    $xmode = $form{'xmode'};
    $modules = $form{'modules'};
    $phtml = 0;
    $ext = '.rsl';
    if ($xmode == 2) {$phtml = 1;}

    open (StdinEmu_file, ">$wdir$tmp_stdin$$");
    print(StdinEmu_file $form{'input'});
    close(StdinEmu_file);

    print "Content-type: text/html\n\n";
    if (!$phtml) {
	print 
	    "<HTML>\n<HEAD>\n<TITLE>REF</TITLE>\n".
	    "<META NAME=\"PRAGMA\" CONTENT=\"no-cache\">".
	    "</HEAD>\n" .
	    "<BODY TEXT=\"#005500\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000EE\" VLINK=\"#551A8B\" ALINK=\"#FF0000\">\n";
    }
    
#We need to test if .rsl file exists and "touch" it...
$now = time;
@files = split (/\+/, $modules);
foreach $file (@files) {
    if (!utime $now, $now, "$wdir$file$ext") {
	print "<h4 align=center><font color=\"#aa0000\"> $file$ext file not found <br>".
	    "You need to go back and recompile source...";
	print "</font></h4>";
    }
}
    if (!$phtml) {
	print "<h4><font color=\"#000077\">Program output: </font></h4>";
	print "<hr>";
	print "<font color=\"#005500\">";
	print `cd $wdir && ../refgo $modules < $tmp_stdin$$ 2>&1 | ../brte.pl`;
	print "</font>";

	print "<hr>";
	print "<center> <font color=\"#000077\">";
	print "<form>".
	     "<INPUT type=button value=\"Back\" onClick=\'javascript: history.go(-1)\'>".
	     '&nbsp;&nbsp;'.
	     "<INPUT type=button value=\"Close\" onClick=\'javascript: window.close ()\'>";
	print "</form>";
	print "</font> </center>";
	

    }else{
	print `cd $wdir && ../refgo $modules < $tmp_stdin$$ 2>&1 `;
    }


    

    if (!$phtml) {
	print "</BODY>\n</HTML>\n";
    }


DeleteExpired ();

    exit 0;
}

if ($state == 1) {
print 
    "Content-type: text/html\n\n" .
    "<HTML>\n<HEAD>\n<TITLE>REF</TITLE>\n".
    "<META NAME=\"PRAGMA\" CONTENT=\"no-cache\">".
    "</HEAD>\n" .
    "<BODY TEXT=\"#005500\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000EE\" VLINK=\"#551A8B\" ALINK=\"#FF0000\">\n";

    @files = split (/,/, $form{'files'});
    
    foreach $file (@files) {
	($file, $ext) = split (/\./, $file);
	
	$modules = sprintf ("%s+%s", $modules, $file);
	
	if (!-e "$wdir$file.rsl") {
	    print "<center>";
	    print "<font color=\"#aa0000\" size=+1> File $wdir$file.rsl doesn't exist.<br>";
	    printf ("Compile <b>\'ref_%d\'</b> refal source file", $index+1);
	    print "</font>";
	    print "</center>";
	    exit 1;
	}
#----------
	$index++;    
    }

    $modules = substr ($modules, 1);

print "<center> <font color=\"#000077\">";
print '<h2>Select execution method</h2>';
print "</font>";
print '<table border=1 bgcolor=#e0e0c0>' .
      '<form method="post" name="xtype" action="execute.cgi?state=2">';
print "<input type=hidden name=modules value=$modules>";
print "<input type=hidden name=xmode value=1>";
print 
    '<tr><td>';


    for ($i = 1; $i<4; $i++) {

	print 
	    "<INPUT TYPE=\"radio\" NAME=\"xmode\" VALUE=$i ";
	printf ("%s", ($i==1)?"CHECKED":"");
	print
	    '   onClick="if (this.checked) {false;}">' .
	    " $i) $xmodes[$i-1]" .
	    '<br>';
    }
print
'</td>' .
'</tr>' .
'<tr><td align=center>' .
'<INPUT type=submit value="Next">' .
'&nbsp;&nbsp;'.
"<INPUT type=button value=\"Close\" onClick=\'javascript: window.close ()\'>".
'</td></tr>' .
'</form>' .
'</table>';
print "</center>";
    
print "</BODY>\n</HTML>\n";
}

if ($state == 2) {
    $xmode = $form{'xmode'};
    $modules = $form{'modules'};

print 
    "Content-type: text/html\n\n" .
    "<HTML>\n<HEAD>\n<TITLE>REF</TITLE>\n".
    "<META NAME=\"PRAGMA\" CONTENT=\"no-cache\">".
    "</HEAD>\n" .
    "<BODY TEXT=\"#005500\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000EE\" VLINK=\"#551A8B\" ALINK=\"#FF0000\">\n";
    print "<center>";
    
    if ($xmode == 1 || $xmode == 2) {
    print '<h3>'. 
	"Execution mode: $xmodes[$xmode-1] <br>". 
	    '</h3>';
	print '<table border=1 bgcolor=#e0e0c0>' .
	    '<form method="post" name="xtype" action="execute.cgi?state=3">';
	print "<input type=hidden name=modules value=$modules>";
	print "<input type=hidden name=xmode value=$xmode>";
	print 
	    '<tr><td>' .
	    '<center>' .
	    'Text below will be pushed to the standard input of the program<br>' .
	    'Please, don\'t forget to type the new-line character (ENTER).' .
	    '</center>' .
	    '<TEXTAREA NAME=input ROWS=15 COLS=70% title="text below will be pushed to the standard input of the program">' .
	    '</textarea>' .
	    '</td></tr>' .
	    '<tr><td align=center>' .
	    '<INPUT type=submit value="Launch">' .
	    '&nbsp;&nbsp;'.
	    "<INPUT type=button value=\"Back\" onClick=\'javascript: history.go(-1)\'>".
	    '&nbsp;&nbsp;'.
	    "<INPUT type=button value=\"Close\" onClick=\'javascript: window.close ()\'>".
	    '</td></tr></form></table>';
    }else{
	if ($xmode == 3){
	    print "<font color=\"#000077\">";
	    print '<h2>Not implemented yet...</h2>';
	    print "</font>";
	    
	    print "<font color=\"#005500\">";
	    print '<h3>'. 
		"Execution mode: $xmodes[$xmode-1] <br>". 
		    "refgo args: $modules". 
			'</h3>';
	    print "</font>";
	}
    }
    print "</center>";
print "</BODY>\n</HTML>\n";
}


sub CheckAndTouch () {
    $now = time;
    
    foreach $file (@files) {
	($file, $ext) = split (/\./, $file);
	$f_name = sprintf ("%s%s%s", $wdir, $file, '.rsl');
	
	if (((@d) = stat($f_name)) && @d[4] == $< && @d[5] == $() {
	    if (!utime ($now, $now, $f_name)) {
		print "can't touch this file... $f_name\n";
	    }
	}
    }
}

CheckAndTouch ();

